## odpic 4.3.0

=== Makefile ===
#------------------------------------------------------------------------------
# Copyright (c) 2016, 2020, Oracle and/or its affiliates.  All rights reserved.
# This program is free software: you can modify it and/or redistribute it
# under the terms of:
#
# (i)  the Universal Permissive License v 1.0 or at your option, any
#      later version (http://oss.oracle.com/licenses/upl); and/or
#
# (ii) the Apache License v 2.0. (http://www.apache.org/licenses/LICENSE-2.0)
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
# Sample Makefile showing how ODPI-C can be built as a shared library on
# platforms other than Windows. For Windows, see Makefile.win32.
#
# See https://oracle.github.io/odpi/doc/installation.html
# for the platforms and compilers known to work.
#------------------------------------------------------------------------------

vpath %.c src
vpath %.h include src

PREFIX ?= /usr/local
INSTALL_LIB_DIR = $(PREFIX)/lib
INSTALL_INC_DIR = $(PREFIX)/include
INSTALL_SHARE_DIR = $(PREFIX)/share/odpi

BUILD_DIR = build
LIB_DIR = lib
SAMPLES_DIR = samples
TESTS_DIR = test

CC = gcc
LD = gcc
AWK = awk

MAJOR_VERSION := $(shell $(AWK) '/define.*DPI_MAJOR_VERSION/ {print $$3}' \
	include/dpi.h )
MINOR_VERSION := $(shell $(AWK) '/define.*DPI_MINOR_VERSION/ {print $$3}' \
	include/dpi.h )
PATCH_LEVEL := $(shell $(AWK) '/define.*DPI_PATCH_LEVEL/ {print $$3}' \
	include/dpi.h )

INSTALL = install
CFLAGS = -Iinclude -O2 -g -Wall -Wextra -fPIC
LIBS = -ldl -lpthread
LDFLAGS = -shared
VERSION_LIB_NAME = $(LIB_NAME).$(MAJOR_VERSION)
FULL_LIB_NAME = $(VERSION_LIB_NAME).$(MINOR_VERSION).$(PATCH_LEVEL)
ifeq ($(shell uname -s), Darwin)
	LIB_NAME = libodpic.dylib
	LIB_OUT_OPTS = -dynamiclib \
		-install_name $(shell pwd)/$(LIB_DIR)/$(LIB_NAME) \
		-o $(LIB_DIR)/$(FULL_LIB_NAME)
else
	LIB_NAME = libodpic.so
	LIB_OUT_OPTS = -o $(LIB_DIR)/$(FULL_LIB_NAME)
	LDFLAGS += -Wl,-soname,$(LIB_NAME).$(MAJOR_VERSION)
endif

SRCS = dpiConn.c dpiContext.c dpiData.c dpiEnv.c dpiError.c dpiGen.c \
       dpiGlobal.c dpiLob.c dpiObject.c dpiObjectAttr.c dpiObjectType.c \
       dpiPool.c dpiStmt.c dpiUtils.c dpiVar.c dpiOracleType.c dpiSubscr.c \
       dpiDeqOptions.c dpiEnqOptions.c dpiMsgProps.c dpiRowid.c dpiOci.c \
       dpiDebug.c dpiHandlePool.c dpiHandleList.c dpiSodaColl.c \
       dpiSodaCollCursor.c dpiSodaDb.c dpiSodaDoc.c dpiSodaDocCursor.c \
       dpiQueue.c dpiJson.c
OBJS = $(SRCS:%.c=$(BUILD_DIR)/%.o)

SAMPLES_FILES := $(SAMPLES_DIR)/Makefile $(SAMPLES_DIR)/README.md \
		$(wildcard $(SAMPLES_DIR)/*.c) $(wildcard $(SAMPLES_DIR)/*.h) \
		$(wildcard $(SAMPLES_DIR)/sql/*.sql)
SAMPLES_TARGETS := $(SAMPLES_FILES:%=$(INSTALL_SHARE_DIR)/%)
INSTALL_SAMPLES_SQL_DIR := $(INSTALL_SHARE_DIR)/$(SAMPLES_DIR)/sql

TESTS_FILES := $(TESTS_DIR)/Makefile $(TESTS_DIR)/README.md \
		$(wildcard $(TESTS_DIR)/*.c) $(wildcard $(TESTS_DIR)/*.h) \
		$(wildcard $(TESTS_DIR)/sql/*.sql)
TESTS_TARGETS := $(TESTS_FILES:%=$(INSTALL_SHARE_DIR)/%)
INSTALL_TESTS_SQL_DIR := $(INSTALL_SHARE_DIR)/$(TESTS_DIR)/sql

INSTALL_TARGETS = $(INSTALL_INC_DIR)/dpi.h \
		$(INSTALL_LIB_DIR)/$(LIB_NAME) $(INSTALL_LIB_DIR)/$(FULL_LIB_NAME) \
		$(INSTALL_LIB_DIR)/$(VERSION_LIB_NAME) $(INSTALL_SHARE_DIR)

all: $(LIB_DIR)/$(FULL_LIB_NAME) $(LIB_DIR)/$(VERSION_LIB_NAME) \
		$(LIB_DIR)/$(LIB_NAME)

clean:
	rm -rf $(BUILD_DIR) $(LIB_DIR)

$(BUILD_DIR):
	mkdir -p $(BUILD_DIR)

$(LIB_DIR):
	mkdir -p $(LIB_DIR)

$(BUILD_DIR)/%.o: %.c dpi.h dpiImpl.h dpiErrorMessages.h
	$(CC) -c $(CFLAGS) $< -o $@

$(LIB_DIR)/$(FULL_LIB_NAME): $(BUILD_DIR) $(LIB_DIR) $(OBJS)
	$(LD) $(LDFLAGS) $(LIB_OUT_OPTS) $(OBJS) $(LIBS)

$(LIB_DIR)/$(VERSION_LIB_NAME): $(LIB_DIR)/$(FULL_LIB_NAME)
	ln -sf $(FULL_LIB_NAME) $@

$(LIB_DIR)/$(LIB_NAME): $(LIB_DIR)/$(VERSION_LIB_NAME)
	ln -sf $(VERSION_LIB_NAME) $@

$(INSTALL_LIB_DIR):
	mkdir -p $@

$(INSTALL_INC_DIR):
	mkdir -p $@

$(INSTALL_SAMPLES_SQL_DIR):
	mkdir -p $@

$(INSTALL_TESTS_SQL_DIR):
	mkdir -p $@

$(INSTALL_INC_DIR)/%.h: %.h
	$(INSTALL) $< $@

$(INSTALL_LIB_DIR)/$(FULL_LIB_NAME): $(LIB_DIR)/$(LIB_NAME)
	$(INSTALL) $< $@
	if test "`uname -s`" = Darwin; then \
			install_name_tool -id $(INSTALL_LIB_DIR)/$(VERSION_LIB_NAME) $@; fi

$(INSTALL_LIB_DIR)/$(VERSION_LIB_NAME): $(INSTALL_LIB_DIR)/$(FULL_LIB_NAME)
	ln -sf $(FULL_LIB_NAME) $@

$(INSTALL_LIB_DIR)/$(LIB_NAME): $(INSTALL_LIB_DIR)/$(VERSION_LIB_NAME)
	ln -sf $(VERSION_LIB_NAME) $@

$(INSTALL_SHARE_DIR)/%: %
	$(INSTALL) $< $@

install: $(INSTALL_SAMPLES_SQL_DIR) $(INSTALL_TESTS_SQL_DIR) \
		$(INSTALL_INC_DIR) $(INSTALL_LIB_DIR) $(INSTALL_TARGETS) \
		$(INSTALL_SHARE_DIR)/README.md $(INSTALL_SHARE_DIR)/LICENSE.md \
		$(SAMPLES_TARGETS) $(TESTS_TARGETS)

uninstall:
	rm -rf $(INSTALL_TARGETS)

=== doc/Makefile ===
#------------------------------------------------------------------------------
# Copyright (c) 2016-2018 Oracle and/or its affiliates.  All rights reserved.
# This program is free software: you can modify it and/or redistribute it
# under the terms of:
#
# (i)  the Universal Permissive License v 1.0 or at your option, any
#      later version (http://oss.oracle.com/licenses/upl); and/or
#
# (ii) the Apache License v 2.0. (http://www.apache.org/licenses/LICENSE-2.0)
#------------------------------------------------------------------------------

# Makefile to generate ODPI-C documentation using Sphinx

SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SOURCEDIR     = src
BUILDDIR      = build

.PHONY: html
html:
	@$(SPHINXBUILD) -M html $(SOURCEDIR) $(BUILDDIR) $(SPHINXOPTS)

.PHONY: epub
epub:
	@$(SPHINXBUILD) -M epub $(SOURCEDIR) $(BUILDDIR) $(SPHINXOPTS)

.PHONY: pdf
pdf:
	@$(SPHINXBUILD) -M latexpdf $(SOURCEDIR) $(BUILDDIR) $(SPHINXOPTS)

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

=== samples/Makefile ===
#------------------------------------------------------------------------------
# Copyright (c) 2016, 2018, Oracle and/or its affiliates. All rights reserved.
# This program is free software: you can modify it and/or redistribute it
# under the terms of:
#
# (i)  the Universal Permissive License v 1.0 or at your option, any
#      later version (http://oss.oracle.com/licenses/upl); and/or
#
# (ii) the Apache License v 2.0. (http://www.apache.org/licenses/LICENSE-2.0)
#
#------------------------------------------------------------------------------
#
# Sample Makefile if you wish to build the ODPI-C sample executables.
#
# Look at README.md for information on how to build and run the samples.
#------------------------------------------------------------------------------

BUILD_DIR = build
INCLUDE_DIR = ../include
LIB_DIR = ../lib

CC=gcc
LD=gcc
CFLAGS=-I$(INCLUDE_DIR) -O2 -g -Wall
LIBS=-L$(LIB_DIR) -lodpic
COMMON_OBJS = $(BUILD_DIR)/SampleLib.o

SOURCES = DemoBLOB.c DemoCLOB.c DemoFetch.c DemoInsert.c DemoInsertAsArray.c \
		DemoCallProc.c DemoRefCursors.c DemoImplicitResults.c \
		DemoFetchObjects.c DemoBindObjects.c DemoFetchDates.c \
		DemoBindArrays.c DemoBFILE.c DemoAppContext.c DemoDistribTrans.c \
		DemoObjectAQ.c DemoRawAQ.c DemoBulkAQ.c DemoCQN.c DemoLongs.c \
		DemoLongRaws.c DemoDMLReturning.c DemoInOutTempLobs.c \
		DemoConvertNumbers.c DemoCreateSodaColl.c DemoIterSodaColls.c \
		DemoDropSodaColl.c DemoInsertSodaColl.c DemoGetSodaDoc.c \
		DemoRemoveSodaDoc.c DemoReplaceSodaDoc.c DemoGetAllSodaDocs.c \
		DemoGetSodaCollNames.c DemoCLOBsAsStrings.c DemoBLOBsAsBytes.c \
		DemoInsertManySodaColl.c DemoShardingNumberKey.c DemoFetchJSON.c \
		DemoBindJSON.c
BINARIES = $(SOURCES:%.c=$(BUILD_DIR)/%)

all: $(BUILD_DIR) $(BINARIES)

clean:
	rm -rf $(BUILD_DIR)

$(BUILD_DIR):
	mkdir -p $@

$(BUILD_DIR)/%.o: %.c SampleLib.h
	$(CC) -c $(CFLAGS) -o $@ $<

$(BUILD_DIR)/%: $(BUILD_DIR)/%.o $(COMMON_OBJS)
	$(LD) $(LDFLAGS) $< -o $@ $(COMMON_OBJS) $(LIBS)

=== test/Makefile ===
#------------------------------------------------------------------------------
# Copyright (c) 2016, 2018, Oracle and/or its affiliates. All rights reserved.
# This program is free software: you can modify it and/or redistribute it
# under the terms of:
#
# (i)  the Universal Permissive License v 1.0 or at your option, any
#      later version (http://oss.oracle.com/licenses/upl); and/or
#
# (ii) the Apache License v 2.0. (http://www.apache.org/licenses/LICENSE-2.0)
#
#------------------------------------------------------------------------------
#
# Sample Makefile if you wish to build the ODPI-C test executables.
#
# Look at README.md for information on how to build and run the tests.
#------------------------------------------------------------------------------

BUILD_DIR = build
INCLUDE_DIR = ../include
LIB_DIR = ../lib

CC = gcc
LD = gcc
CFLAGS = -I$(INCLUDE_DIR) -O2 -g -Wall
LIBS = -L$(LIB_DIR) -lodpic
COMMON_OBJS = $(BUILD_DIR)/TestLib.o

SOURCES = TestSuiteRunner.c \
		  test_1000_context.c \
		  test_1100_numbers.c \
		  test_1200_conn.c \
		  test_1300_conn_properties.c \
		  test_1400_pool.c \
		  test_1500_pool_properties.c \
		  test_1600_queries.c \
		  test_1700_transactions.c \
		  test_1800_misc.c \
		  test_1900_variables.c \
		  test_2000_statements.c \
		  test_2100_data_types.c \
		  test_2200_object_types.c \
		  test_2300_objects.c \
		  test_2400_enq_options.c \
		  test_2500_deq_options.c \
		  test_2600_msg_props.c \
		  test_2700_aq.c \
		  test_2800_lobs.c \
		  test_2900_implicit_results.c \
		  test_3000_scroll_cursors.c \
		  test_3100_subscriptions.c \
		  test_3200_batch_errors.c \
		  test_3300_dml_returning.c \
		  test_3400_soda_db.c \
		  test_3500_soda_coll.c \
		  test_3600_soda_coll_cursor.c \
		  test_3700_soda_doc.c \
		  test_3800_soda_doc_cursor.c \
		  test_3900_sess_tags.c \
		  test_4000_queue.c \
		  test_4100_binds.c \
		  test_4200_rowids.c \
		  test_4300_json.c
BINARIES = $(SOURCES:%.c=$(BUILD_DIR)/%)

all: $(BUILD_DIR) $(BINARIES)

clean:
	rm -rf $(BUILD_DIR)

$(BUILD_DIR):
	mkdir -p $@

$(BUILD_DIR)/%.o: %.c TestLib.h
	$(CC) -c $(CFLAGS) -o $@ $<

$(BUILD_DIR)/%: $(BUILD_DIR)/%.o $(COMMON_OBJS)
	$(LD) $(LDFLAGS) $< -o $@ $(COMMON_OBJS) $(LIBS)

=== debian/changelog ===
odpic (4.3.0-3) unstable; urgency=medium

  * [a773491] fix Vcs URLs
  * [1e1bc40] clean doctrees as a dir.
    Thanks to Andreas Beckmann <anbe@debian.org> (Closes: 1004614)
  * [c9b1882] drop libaio1 from Dep to Rec.
    This is just a convenience dep as libodpic doesn't directly use libaio1,
    but it is needed by the (unpackagable) Oracle Instant Client -- which is
    needed by libodpic.
  * [980534d] add more info about Oracle client installation to README.Debian

 -- Joseph Nahmias <jello@debian.org>  Tue, 01 Feb 2022 06:02:48 -0500

odpic (4.3.0-2) unstable; urgency=medium

  * [eb2e04a] update homepage URL
  * [2cfc490] add dep on libaio1 needed by Oracle Instant Client
  * [d9a5e64] move python3-sphinx to Build-Deps (Closes: 1004408)

 -- Joseph Nahmias <jello@debian.org>  Wed, 26 Jan 2022 22:09:04 -0500

odpic (4.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #1000295).
  * [54682c8] add symbols file
  * [e059b34] support DESTDIR for install
  * [31e82f9] fix spelling error
  * [9503943] fix handling of build env vars

 -- Joseph Nahmias <jello@debian.org>  Sat, 20 Nov 2021 23:37:33 -0500

=== debian/control ===
Source: odpic
Priority: optional
Maintainer: Joseph Nahmias <jello@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 python3-sphinx <!nodoc>,
Standards-Version: 4.6.0
Section: contrib/libs
Homepage: https://oracle.github.io/odpi/
Vcs-Browser: https://salsa.debian.org/debian/odpic
Vcs-Git: https://salsa.debian.org/debian/odpic.git
Rules-Requires-Root: no

Package: odpic-dev
Section: contrib/libdevel
Architecture: any
Multi-Arch: same
Depends: libodpic4 (= ${binary:Version}), ${misc:Depends}
Recommends: odpic-doc
Description: Oracle Database Programming Interface development files
 Oracle Database Programming Interface for C (ODPI-C) is an open source
 library of C code that simplifies access to Oracle Database for applications
 written in C or C++. It is a wrapper over Oracle Call Interface (OCI) that
 makes applications and language interfaces easier to develop.
 .
 ODPI-C supports basic and advanced features of Oracle Database and Oracle
 Client. See the homepage for a list.
 .
 This package contains the files needed to develop programs that use ODPI-C;
 including the headers, examples, and sample programs.

Package: libodpic4
Section: contrib/libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libaio1
Description: Oracle Database Programming Interface runtime C shared library
 Oracle Database Programming Interface for C (ODPI-C) is an open source
 library of C code that simplifies access to Oracle Database for applications
 written in C or C++. It is a wrapper over Oracle Call Interface (OCI) that
 makes applications and language interfaces easier to develop.
 .
 ODPI-C supports basic and advanced features of Oracle Database and Oracle
 Client. See the homepage for a list.
 .
 This package contains the C shared library needed to run programs that
 dynamically link to ODPI-C.

Package: odpic-doc
Section: contrib/doc
Architecture: all
Multi-Arch: foreign
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: Oracle Database Programming Interface documentation
 Oracle Database Programming Interface for C (ODPI-C) is an open source
 library of C code that simplifies access to Oracle Database for applications
 written in C or C++. It is a wrapper over Oracle Call Interface (OCI) that
 makes applications and language interfaces easier to develop.
 .
 ODPI-C supports basic and advanced features of Oracle Database and Oracle
 Client. See the homepage for a list.
 .
 This package contains the developer documentation for ODPI-C.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_VERBOSE = 1

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
ifeq (,$(filter nodoc,${DEB_BUILD_OPTIONS} ${DEB_BUILD_PROFILES}))
	dh $@ --with sphinxdoc
else
	dh $@
endif

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build
ifeq (,$(filter nodoc,${DEB_BUILD_OPTIONS} ${DEB_BUILD_PROFILES}))
	python3 -m sphinx -N -bhtml doc/src -d debian/doctrees build/html
endif

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr
	find $(CURDIR)/debian/tmp/usr/share/odpi/samples/ -type f -print0 \
	    | xargs -0 chmod -x

## odpic 4.6.0

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,25 @@
 #------------------------------------------------------------------------------
-# Copyright (c) 2016, 2020, Oracle and/or its affiliates.  All rights reserved.
-# This program is free software: you can modify it and/or redistribute it
-# under the terms of:
+# Copyright (c) 2016, 2022, Oracle and/or its affiliates.
 #
-# (i)  the Universal Permissive License v 1.0 or at your option, any
-#      later version (http://oss.oracle.com/licenses/upl); and/or
+# This software is dual-licensed to you under the Universal Permissive License
+# (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl and Apache License
+# 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose
+# either license.
 #
-# (ii) the Apache License v 2.0. (http://www.apache.org/licenses/LICENSE-2.0)
+# If you elect to accept the software under the Apache License, Version 2.0,
+# the following applies:
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#    https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
 #------------------------------------------------------------------------------
 
 #------------------------------------------------------------------------------
@@ -138,7 +151,7 @@
 
 install: $(INSTALL_SAMPLES_SQL_DIR) $(INSTALL_TESTS_SQL_DIR) \
 		$(INSTALL_INC_DIR) $(INSTALL_LIB_DIR) $(INSTALL_TARGETS) \
-		$(INSTALL_SHARE_DIR)/README.md $(INSTALL_SHARE_DIR)/LICENSE.md \
+		$(INSTALL_SHARE_DIR)/README.md $(INSTALL_SHARE_DIR)/LICENSE.txt \
 		$(SAMPLES_TARGETS) $(TESTS_TARGETS)
 
 uninstall:

=== samples/Makefile ===
--- 
+++ 
@@ -1,12 +1,25 @@
 #------------------------------------------------------------------------------
-# Copyright (c) 2016, 2018, Oracle and/or its affiliates. All rights reserved.
-# This program is free software: you can modify it and/or redistribute it
-# under the terms of:
+# Copyright (c) 2016, 2022, Oracle and/or its affiliates.
 #
-# (i)  the Universal Permissive License v 1.0 or at your option, any
-#      later version (http://oss.oracle.com/licenses/upl); and/or
+# This software is dual-licensed to you under the Universal Permissive License
+# (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl and Apache License
+# 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose
+# either license.
 #
-# (ii) the Apache License v 2.0. (http://www.apache.org/licenses/LICENSE-2.0)
+# If you elect to accept the software under the Apache License, Version 2.0,
+# the following applies:
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#    https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
 #
 #------------------------------------------------------------------------------
 #
@@ -36,7 +49,7 @@
 		DemoRemoveSodaDoc.c DemoReplaceSodaDoc.c DemoGetAllSodaDocs.c \
 		DemoGetSodaCollNames.c DemoCLOBsAsStrings.c DemoBLOBsAsBytes.c \
 		DemoInsertManySodaColl.c DemoShardingNumberKey.c DemoFetchJSON.c \
-		DemoBindJSON.c
+		DemoBindJSON.c DemoTokenStandalone.c DemoTokenPoolWithCallback.c
 BINARIES = $(SOURCES:%.c=$(BUILD_DIR)/%)
 
 all: $(BUILD_DIR) $(BINARIES)

=== test/Makefile ===
--- 
+++ 
@@ -1,12 +1,25 @@
 #------------------------------------------------------------------------------
-# Copyright (c) 2016, 2018, Oracle and/or its affiliates. All rights reserved.
-# This program is free software: you can modify it and/or redistribute it
-# under the terms of:
+# Copyright (c) 2016, 2022, Oracle and/or its affiliates.
 #
-# (i)  the Universal Permissive License v 1.0 or at your option, any
-#      later version (http://oss.oracle.com/licenses/upl); and/or
+# This software is dual-licensed to you under the Universal Permissive License
+# (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl and Apache License
+# 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose
+# either license.
 #
-# (ii) the Apache License v 2.0. (http://www.apache.org/licenses/LICENSE-2.0)
+# If you elect to accept the software under the Apache License, Version 2.0,
+# the following applies:
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#    https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
 #
 #------------------------------------------------------------------------------
 #

=== debian/changelog ===
odpic (4.6.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * [a8d4153] Set upstream metadata fields: Repository-Browse.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-file-is-missing
    See-also: https://lintian.debian.org/tags/upstream-metadata-file-is-missing.html
  * [8a1f647] Update standards version to 4.6.1, no changes needed.
    Changes-By: lintian-brush
    Fixes: lintian: out-of-date-standards-version
    See-also: https://lintian.debian.org/tags/out-of-date-standards-version.html
  * [d892476] Remove field Section on binary package libodpic4 that duplicates source.
    Changes-By: lintian-brush
    Fixes: lintian: installable-field-mirrors-source
    See-also: https://lintian.debian.org/tags/installable-field-mirrors-source.html

  [ Joseph Nahmias ]
  * [fbf19b0] New upstream version 4.6.0
  * [799b9ed] move sphinx to B-D-I and use dh-seq-sphinxdoc
  * [f90b397] factor out common part of pkg descriptions
  * [1b15f8d] properly install upstream's release notes as the changelog
  * [8463322] also list LICENSE.txt as not-installed
  * [1fd9636] refresh patches
  * [5e9e181] update symbols

 -- Joseph Nahmias <jello@debian.org>  Mon, 09 Jan 2023 14:12:57 -0500

=== debian/control ===
Source: odpic
Priority: optional
Maintainer: Joseph Nahmias <jello@debian.org>
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
 python3-sphinx <!nodoc>,
Standards-Version: 4.6.1
Section: contrib/libs
Homepage: https://oracle.github.io/odpi/
Vcs-Browser: https://salsa.debian.org/debian/odpic
Vcs-Git: https://salsa.debian.org/debian/odpic.git
Rules-Requires-Root: no
Description: Oracle Database Programming Interface
 Oracle Database Programming Interface for C (ODPI-C) is an open source
 library of C code that simplifies access to Oracle Database for applications
 written in C or C++. It is a wrapper over Oracle Call Interface (OCI) that
 makes applications and language interfaces easier to develop.
 .
 ODPI-C supports basic and advanced features of Oracle Database and Oracle
 Client. See the homepage for a list.

Package: odpic-dev
Section: contrib/libdevel
Architecture: any
Multi-Arch: same
Depends: libodpic4 (= ${binary:Version}), ${misc:Depends}
Recommends: odpic-doc
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 This package contains the files needed to develop programs that use ODPI-C;
 including the headers, examples, and sample programs.

Package: libodpic4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libaio1
Description: ${source:Synopsis} - runtime C shared library
 ${source:Extended-Description}
 .
 This package contains the C shared library needed to run programs that
 dynamically link to ODPI-C.

Package: odpic-doc
Section: contrib/doc
Architecture: all
Multi-Arch: foreign
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package contains the developer documentation for ODPI-C.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_VERBOSE = 1

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

execute_after_dh_auto_build-indep: export http_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep:
ifeq (,$(filter nodoc,${DEB_BUILD_OPTIONS} ${DEB_BUILD_PROFILES}))
	python3 -m sphinx -N -bhtml doc/src -d debian/doctrees build/html
endif

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr
	find $(CURDIR)/debian/tmp/usr/share/odpi/samples/ -type f -print0 \
	    | xargs -0 chmod -x

override_dh_installchangelogs:
	dh_installchangelogs doc/src/releasenotes.rst

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%odpic-$1.tar.gz%" \
   https://github.com/oracle/odpi/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## odpic 5.6.3

=== debian/changelog ===
odpic (5.6.3-1) unstable; urgency=low

  * New upstream version 5.6.3
  * Set myself as maintainer (Closes: #1121502).
  * Bump Standards-Version to 4.7.3.
  * Add debian/gbp.conf.
  * Refresh and renumber patches.
  * Bump SONAME version to 5.
  * Run wrap-and-sort -bast to reduce diff size of future changes.
  * Extend upstream metadata.
  * Append '-shared' to LDFLAGS.
  * Use uscan version 5.
  * Drop Rules-Requires-Root.
  * Use $(CURDIR) in d/rules.
  * Update symbols for libodpic5.
  * Remove old 0003-do_not_overwrite_build_env_flags patch.
  * Add patch to include CPPFLAGS when building.
  * Update year in d/copyright.

 -- Michael Fladischer <fladi@debian.org>  Mon, 19 Jan 2026 12:17:32 +0000

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # package maintainers to append CFLAGS
 #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # package maintainers to append LDFLAGS
-#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+export DEB_LDFLAGS_MAINT_APPEND = -shared
 
 %:
 	dh $@
@@ -16,7 +16,7 @@
 execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
 execute_after_dh_auto_build-indep:
 ifeq (,$(filter nodoc,${DEB_BUILD_OPTIONS} ${DEB_BUILD_PROFILES}))
-	python3 -m sphinx -N -bhtml doc/src -d debian/doctrees build/html
+	python3 -m sphinx -N -bhtml $(CURDIR)/doc/src -d $(CURDIR)/debian/doctrees $(CURDIR)/build/html
 endif
 
 override_dh_auto_install:

## odpic 5.6.4

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #------------------------------------------------------------------------------
-# Copyright (c) 2016, 2022, Oracle and/or its affiliates.
+# Copyright (c) 2016, 2025, Oracle and/or its affiliates.
 #
 # This software is dual-licensed to you under the Universal Permissive License
 # (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl and Apache License
@@ -43,9 +43,8 @@
 SAMPLES_DIR = samples
 TESTS_DIR = test
 
-CC = gcc
-LD = gcc
-AWK = awk
+CC ?= gcc
+AWK ?= awk
 
 MAJOR_VERSION := $(shell $(AWK) '/define.*DPI_MAJOR_VERSION/ {print $$3}' \
 	include/dpi.h )
@@ -54,10 +53,13 @@
 PATCH_LEVEL := $(shell $(AWK) '/define.*DPI_PATCH_LEVEL/ {print $$3}' \
 	include/dpi.h )
 
-INSTALL = install
-CFLAGS = -Iinclude -O2 -g -Wall -Wextra -fPIC
-LIBS = -ldl -lpthread
-LDFLAGS = -shared
+INSTALL ?= install
+CFLAGS ?= -O2 -g -Wall -Wextra -fPIC
+EXTRA_CFLAGS ?=
+INCLUDES ?= -Iinclude
+LIBS ?= -ldl -lpthread
+LDFLAGS ?= -shared
+EXTRA_LDFLAGS ?=
 VERSION_LIB_NAME = $(LIB_NAME).$(MAJOR_VERSION)
 FULL_LIB_NAME = $(VERSION_LIB_NAME).$(MINOR_VERSION).$(PATCH_LEVEL)
 ifeq ($(shell uname -s), Darwin)
@@ -77,7 +79,7 @@
        dpiDeqOptions.c dpiEnqOptions.c dpiMsgProps.c dpiRowid.c dpiOci.c \
        dpiDebug.c dpiHandlePool.c dpiHandleList.c dpiSodaColl.c \
        dpiSodaCollCursor.c dpiSodaDb.c dpiSodaDoc.c dpiSodaDocCursor.c \
-       dpiQueue.c dpiJson.c
+       dpiQueue.c dpiJson.c dpiStringList.c dpiVector.c
 OBJS = $(SRCS:%.c=$(BUILD_DIR)/%.o)
 
 SAMPLES_FILES := $(SAMPLES_DIR)/Makefile $(SAMPLES_DIR)/README.md \
@@ -109,10 +111,10 @@
 	mkdir -p $(LIB_DIR)
 
 $(BUILD_DIR)/%.o: %.c dpi.h dpiImpl.h dpiErrorMessages.h
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) -c $(INCLUDES) $(CFLAGS) $(EXTRA_CFLAGS) $< -o $@
 
 $(LIB_DIR)/$(FULL_LIB_NAME): $(BUILD_DIR) $(LIB_DIR) $(OBJS)
-	$(LD) $(LDFLAGS) $(LIB_OUT_OPTS) $(OBJS) $(LIBS)
+	$(CC) $(LDFLAGS) $(EXTRA_LDFLAGS) $(LIB_OUT_OPTS) $(OBJS) $(LIBS)
 
 $(LIB_DIR)/$(VERSION_LIB_NAME): $(LIB_DIR)/$(FULL_LIB_NAME)
 	ln -sf $(FULL_LIB_NAME) $@

=== test/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #------------------------------------------------------------------------------
-# Copyright (c) 2016, 2022, Oracle and/or its affiliates.
+# Copyright (c) 2016, 2025, Oracle and/or its affiliates.
 #
 # This software is dual-licensed to you under the Universal Permissive License
 # (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl and Apache License
@@ -72,7 +72,9 @@
 		  test_4000_queue.c \
 		  test_4100_binds.c \
 		  test_4200_rowids.c \
-		  test_4300_json.c
+		  test_4300_json.c \
+		  test_4400_vector.c \
+          test_4500_sessionless_txn.c
 BINARIES = $(SOURCES:%.c=$(BUILD_DIR)/%)
 
 all: $(BUILD_DIR) $(BINARIES)

=== debian/changelog ===
odpic (5.6.4-1) unstable; urgency=low

  * New upstream version 5.6.4

 -- Michael Fladischer <fladi@debian.org>  Tue, 27 Jan 2026 13:22:52 +0000

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: odpic
 Priority: optional
-Maintainer: Joseph Nahmias <jello@debian.org>
+Maintainer: Michael Fladischer <fladi@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Indep:
  dh-sequence-sphinxdoc,
  python3-sphinx <!nodoc>,
-Standards-Version: 4.6.1
+ python3-sphinx-rtd-theme <!nodoc>,
+Standards-Version: 4.7.3
 Section: contrib/libs
 Homepage: https://oracle.github.io/odpi/
 Vcs-Browser: https://salsa.debian.org/debian/odpic
 Vcs-Git: https://salsa.debian.org/debian/odpic.git
-Rules-Requires-Root: no
 Description: Oracle Database Programming Interface
  Oracle Database Programming Interface for C (ODPI-C) is an open source
  library of C code that simplifies access to Oracle Database for applications
@@ -25,19 +25,25 @@
 Section: contrib/libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libodpic4 (= ${binary:Version}), ${misc:Depends}
-Recommends: odpic-doc
+Depends:
+ libodpic5 (= ${binary:Version}),
+ ${misc:Depends},
+Recommends:
+ odpic-doc,
 Description: ${source:Synopsis} - development files
  ${source:Extended-Description}
  .
  This package contains the files needed to develop programs that use ODPI-C;
  including the headers, examples, and sample programs.
 
-Package: libodpic4
+Package: libodpic5
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: libaio1
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Recommends:
+ libaio1,
 Description: ${source:Synopsis} - runtime C shared library
  ${source:Extended-Description}
  .
@@ -48,7 +54,9 @@
 Section: contrib/doc
 Architecture: all
 Multi-Arch: foreign
-Depends: ${sphinxdoc:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${sphinxdoc:Depends},
 Description: ${source:Synopsis} - documentation
  ${source:Extended-Description}
  .

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=5

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%odpic-$1.tar.gz%" \
   https://github.com/oracle/odpi/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
